#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include "traqueboule.h"
#include "argumentParser.h"


// Utilis pour essayer diffrents types de rendu
// Utilis via le paramtre "-t" en ligne de commande
// LASTTYPE N'EST UTILISE QUE POUR CONNAITRE LA FIN DE LA LISTE
enum { CUBE=0, NAVIGATION=1
	, LASTTYPE
};
unsigned int type = CUBE;

unsigned int W_fen = 800;  // largeur fenetre
unsigned int H_fen = 800;  // hauteur fenetre

/**
 * Paramtres de camra
 */
float zCamera = 3.0;

float znear = 1;
float zfar = 5;


//
// FIN DES HEADERS
//

void dessinerCube()
{
	glColor3f( 1.0, 1.0, 1.0 );
	glutWireCube( 2.0 );
}



void dessinerFrustum()
{
}



/**
 * Appel des diffrentes fonctions de dessin
*/
void dessiner( )
{
	switch( type )
	{
	case CUBE:
		dessinerCube();
		break;
	case NAVIGATION:
		// Pour tout bien voir
		glScalef( 0.25, 0.25, 0.25 );
		dessinerCube();
		dessinerFrustum();
		break;
	default:
		dessinerCube(); // Par dfaut
		break;
	}
}


/**
 * Initiliasation et suppression
 */

void initDonnees()
{
}

void finDonnees()
{
}


/**
 * Camra
 **************************/

 
/**
 * Dfini la camra perspective
 */
void definirCamera( float aspect )
{
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    
    if( type == CUBE )
    {
    // Permet de dfinir simplement la camra
    
    glFrustum(	-1, 1,			// Plans gauche et droit
             	-1, 1, 			// Plans bas et haut
		znear, zfar	// Plan proche et loin
			 );
         
    // ou si l'on veut faire de l'orthographique, utiliser cette fonction (cf. documentation)
    //glLoadIdentity(); glOrtho (-1.1, 1.1, -1.1,1.1, znear, zfar );
    }
    else
    {
    	gluPerspective (50, aspect, 1, 10);
	// ou si l'on veut faire de l'orthographique, utiliser cette fonction (cf. documentation)
	//glLoadIdentity(); glOrtho (-1.1, 1.1, -1.1,1.1, znear, zfar );
    }
    
    glMatrixMode(GL_MODELVIEW);
}


void placerCamera( float z )
{
	// On doit tre dans la matrice MODEL_VIEW
	// cad : la matrice perspective doit tre dfinie
	glLoadIdentity();
	
	// Par dfaut,  commenter plus tard
	// Recule la camra
	glTranslatef( 0, 0, z );
}












/**
 * Initialise la/les lumires
 */
void initLights()
{
}

float dz=0.1;

void display(void);
void reshape(int w, int h);
void keyboard(unsigned char key, int x, int y);

/**
 * Programme principal
 */
int main(int argc, char** argv)
{
	
    animal::parse("Camra. Voici la liste des options: ")
    .option(&W_fen,'L',"Largeur","largeur de la fentre en pixels")
    .option(&H_fen,'H',"Hauteur","hauteur de la fentre en pixels")
    .option(&type,'t',"type","type de rendu")
    .option(&dz,'z',"dz","vitesse de changement de z (doit tre positif !)")
    (argc,argv);

    initDonnees( ); 
    
    glutInit(&argc, argv);

    // couches du framebuffer utilisees par l'application
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH );

    // position et taille de la fenetre
    glutInitWindowPosition(200, 100);
    glutInitWindowSize(W_fen,H_fen);
    glutCreateWindow(argv[0]);

    initLights();

	
        tbInitTransform();     // initialisation du point de vue
    

    // cablage des callback
    glutReshapeFunc(reshape);
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(display);
    glutMouseFunc(tbMouseFunc);    // traqueboule utilise la souris
    glutMotionFunc(tbMotionFunc);  // traqueboule utilise la souris
    glutIdleFunc( display );

    // lancement de la boucle principale
    glutMainLoop();
    
    finDonnees();
    
    return 0;  // instruction jamais excute
}



/**
 * Fonctions de gestion opengl  ne pas toucher
 */
// Actions d'affichage
// Ne pas changer
void display(void)
{
    // Details sur le mode de trac
    glEnable( GL_DEPTH_TEST );            // effectuer le test de profondeur
    //glEnable(GL_CULL_FACE);
    //glCullFace(GL_BACK);
    glPolygonMode(GL_FRONT,GL_FILL);
    glPolygonMode(GL_BACK,GL_LINE);
    glShadeModel(GL_FLAT);

    // Effacer tout
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT); // la couleur et le z
    
    
    
    // Dfini la camra perspective
    definirCamera( (float)W_fen/H_fen );
    
    if( type == CUBE )
    {
    	// Place la camra dans l'espace
    	placerCamera( -zCamera );
    }
    else
    {
    	// Utilisation de la souris pour naviguer
	placerCamera( -3 );
    	tbVisuTransform(); // origine et orientation de la scene
    
    }
 
	
	
    dessiner( );

    
    
    glutSwapBuffers();
}
// pour changement de taille ou desiconification
void reshape(int w, int h)
{
	W_fen = w;
	H_fen = h;
	
	// Change effectivement la taille de la fentre openGL
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	
	// Redfinit la camra en fonction
	definirCamera( (float)w/h);
	
	glutPostRedisplay();
}


// prise en compte du clavier
void keyboard(unsigned char key, int mousex, int mousey)
{
    //printf("key %d pressed at %d,%d\n",key,mousex,mousey);
    //fflush(stdout);
    switch (key)
    {
    case 27:     // touche ESC
        exit(0);
    case 'z':
    	zCamera -= dz;
    	break;
    case 'Z':
    	zCamera += dz;
    	break;
    case 'n':
	// znear ne doit pas etre nul !
    	znear = fmax(dz,znear-dz);
	// on pourrait utiliser pour ce plan : znear = 0.9*znear;
	break;
    case 'N':
    	znear += dz;
	// on pourrait utiliser pour ce plan : znear = 1.1*znear;
	break;
    case 'f':
    	// zfar doit etre plus grand que znear
    	zfar = fmax(znear+dz,zfar-dz);
	break;
    case 'F':
    	zfar += dz;
	break;
    case 't':
    	type = (type+1)%(LASTTYPE);
	break;
    }
    fprintf( stderr, "Camera : %f, znear : %f, zfar : %f\n", zCamera, znear, zfar );
}

